{-------------------------------------------------------------}
{
{    Programa de Transferncia Remota de Arquivos
{
{    Rotina para ler diretorio remoto
{
{    Autor: Jose' Antonio Borges
{
{    Em 21/04/98
{
{-------------------------------------------------------------}

unit ftpDir;
interface

uses dvCrt, dvWin, dvForm, sysUtils, winsock, winprocs,
     windows,
     ftpVars, ftpMsg, ftpDlg, ftpPort, ftpRede, ftpArq;

procedure processaDiretorio;
procedure trocaSubdiretorio;

implementation

{-------------------------------------------------------------}
{                          ajuda
{-------------------------------------------------------------}

procedure ajuda;
begin
    mensagem ('FTPAJA01', 1);  {'As opes so'}
    mensagem ('FTPAJA02', 1);  {'R - recebe o arquivo que foi falado'}
    mensagem ('FTPAJA03', 1);  {'A - apaga o arquivo'}
    mensagem ('FTPAJA04', 1);  {'D - dados sobre o arquivo'}
    mensagem ('FTPAJA05', 1);  {'V - vai para o diretrio pai'}
    mensagem ('FTPAJA06', 1);  {'T - troca para o diretrio falado'}
    mensagem ('FTPAJA10', 1);  {'ESQ, DIR - soletra nome com as setas'}
    mensagem ('FTPAJA11', 1);  {'CTRL INS - joga o nome na rea de transferncia'}
    mensagem ('FTPAJA12', 1);  {'ESC - volta ao menu principal do ftp'}

    while keypressed do readkey;
    sintBip;
end;

{--------------------------------------------------------}
{            seleciona a opo com as setas
{--------------------------------------------------------}

function selSetasOpcao: char;

    procedure MenuAdiciona (msg: string);
    begin
         popupMenuAdiciona (msg, pegaTextoMensagem (msg));
    end;

var n: integer;
const
    tabLetrasOpcoes: string [5] = 'radvt';

begin
    popupMenuCria (40, wherey, 50, 5, MAGENTA);
    MenuAdiciona ('FTPAJA02');  {'R - recebe o arquivo que foi falado'}
    MenuAdiciona ('FTPAJA03');  {'A - apaga o arquivo'}
    MenuAdiciona ('FTPAJA04');  {'D - dados sobre o arquivo'}
    MenuAdiciona ('FTPAJA05');  {'V - vai para o diretrio pai'}
    MenuAdiciona ('FTPAJA06');  {'T - troca para o diretrio falado'}
    n := popupMenuSeleciona;
    if n > 0 then
        selSetasOpcao := tabLetrasOpcoes[n]
    else
        selSetasOpcao := ENTER;
end;

{-------------------------------------------------------------}
{                   Apaga um arquivo
{-------------------------------------------------------------}

function apagaArq (nome: string): boolean;
var c: char;
    codigo: integer;
begin
    apagaArq := false;
    if nome = '' then
        begin
            sintBip;
            exit;
        end;

    writeln;
    mensagem ('FTCNFAPA', 1);  {'Confirme apagamento de'}
    sintWrite (nome + '?  ');
    mensagem ('FTSIMNAO', 0); {Sim ou nao?}
    c := readKey;
    sintWriteln (c);
    if (upcase (c) <> 'S') or (c = ESC) then
        begin
             mensagem ('FTDESIS', 2);   {'Desistiu'}
             exit;
        end;

    if enviaComando ('DELE ' + nome) then
        begin
            mostraRespostas (codigo);
            if (codigo = 125) or (codigo = 150) or (codigo = 250) then
                mensagem ('FTOKAPAG', 1)   {'Ok, apagado'}
            else
                mensagem ('FTNAOAPA', 1);  {'No consegui apagar este arquivo'}
        end;
end;

{-------------------------------------------------------------}
{               troca diretrio atual
{-------------------------------------------------------------}

function trocaDir (nome: string): boolean;
var codigo: integer;
begin
    trocaDir := false;
    if nome = '' then
        begin
            sintBip;
            exit;
        end;

    if enviaComando ('CWD '+ nome) then
      begin
          mostraRespostas (codigo);
          if (codigo = 250) or (codigo = 200) then
              begin
                  mensagem ('FTOK', 1);  {'OK'}
                  trocaDir := true;
              end
          else
              mensagem ('FTNAOTRO', 1);  {'No consegui trocar'}
      end;
end;

{-------------------------------------------------------------}
{                    le o diretorio trazido
{-------------------------------------------------------------}

procedure leDiretorio;
type
     stringDir = string[150];
     diretorio = array [1..15000] of ^stringDir;
var
    n, nent: integer;
    pdir: ^diretorio;
    arqDir: text;
    nome, s: string;
    c: char;
    codigo: integer;

            procedure extraiNome (s: string; var nome: string);
            var i: integer;
            begin
                 nome := '';
                 while (s <> '') and
                       ((s [length(s)] = ' ') or (s [length(s)] = #$0)) do
                     delete (s, length(s), 1);

                 i := length (s);
                 while (i > 0) and (s[i] <> ' ') do
                     begin
                         nome := s[i] + nome;
                         i := i - 1;
                     end;
            end;

            procedure mostraNomeDir (n: integer);
            var nome: string;
            begin
                 writeln;
                 extraiNome (pdir^[n]^, nome);
                 sintWrite (nome);
                 if pdir^[n]^[1] = 'd' then
                      begin
                          gotoxy (30, wherey);
                          sintWrite ('  diretrio');
                      end;
            end;


label fim, executa;

begin
    assign (arqDir, nomeArqDir);
    {$I-}  reset (arqDir);  {$I+}
    if ioresult <> 0 then
        begin
            mensagem ('FTERTEMP', 1);  {'Problemas com o arquivo temporrio, no posso ler o diretrio'}
            exit;
        end;

    new (pdir);
    nent := 0;
    while not eof (arqDir) do
        begin
            readln (arqDir, s);
            nent := nent + 1;
            new (pdir^[nent]);
            pdir^[nent]^ := s;
        end;

    mensagem ('FTUSSETA', 1);
                {Use as setas para selecionar arquivos ou subdiretrios,
                    F9 - menu, ESC termina}
    while sintFalando do;

    n := 1;
    repeat
        if (n >= 1) and (n <= nent) then
            mostraNomeDir (n);

        c := readKey;

executa:
        if (n >= 1) and (n <= nent) then
            extraiNome (pdir^[n]^, nome)
        else
            nome := '';

        case upcase(c) of
        'R':
            if nome <> '' then
                begin
                    writeln;
                    iniciaRecepcao (nome);
                end
            else
                sintBip;

        'A':
            begin
                if apagaArq (nome) then
                    begin
                        n := n - 1;
                        nent := nent - 1;
                    end;
            end;

        'D':
            if enviaComando ('SIZE ' + nome) then
                begin
                    write (' .... ');
                    falaRespostas (codigo, false);
                end;

        'V':
            if trocaDir ('..') then goto fim;

        'T':
            if trocaDir (nome) then goto fim;

        #$0:
            begin
                c := readkey;
                case c of
                    F9: begin
                            c := selSetasOpcao;
                            goto executa;
                        end;

                    CIMA:    n := n - 1;
                    BAIX:    n := n + 1;
                    PGUP:    n := n - 5;
                    PGDN:    n := n + 5;
                    CTLPGUP, HOME: n := 0;
                    CTLPGDN, TEND: n := nent + 1;

                    ESQ, DIR:
                        begin
                                if (n >= 1) or (n <= nent) then
                                    begin
                                        s := pdir^[n]^;
                                        c := sintEdita (s, 1, wherey, length (s), false);
                                    end;
                            end;

                    CTLINS: begin
                                 s := nome + #$0;
                                 mensagem ('FTOK', 1);   {ok}
                                 putClipboard (@s[1]);
                             end;
                end;
            end;
        end;

        while pins <> pret do
            begin
                if wherex <> 0 then writeln;
                mostraRespostas (codigo);
            end;

        if n < 1 then
            begin
                n := 0;
                writeln;
                mensagem ('FTULTARQ', 1);  {'Ultimo arquivo...'}
            end
        else
        if n > nent then
            begin
                n := nent + 1;
                writeln;
                mensagem ('FTULTARQ', 1);  {'Ultimo arquivo...'}
            end;

    until c = #$1b;

fim:
    for n := 1 to nent do
       dispose (pdir^[n]);
    dispose (pdir);

    close (arqDir);

    writeln;
    while keypressed do readkey;
end;

{-------------------------------------------------------------}
{                      processa diretrio
{-------------------------------------------------------------}

procedure processaDiretorio;
var i, codigo, ev: integer;
begin
    while pins <> pret do
        mostraRespostas (codigo);

    if enviaComando ('TYPE A') then
        mostraRespostas (codigo)
    else
        exit;

    if not modoPassivo then
        begin
            if not trocaPortaLocal then exit;
        end
    else
        begin
            if not trocaPortaPassiva then exit;
        end;

    assign (arqLocal, nomeArqDir);
    {$I-}  rewrite (arqLocal, 1);  {$I+}
    if ioresult <> 0 then
        begin
            mensagem ('FTERRCRI', 1);  {'No consegui criar o arquivo para receber o diretorio'}
            exit;
        end;

    mensagem ('FTDIRPED', 1);  {'Diretorio pedido, aguarde'}
    if abreConexaoArq then
        begin
            totalTransmitido := 0;
            if enviaComando ('LIST') then
                begin
                    mostraRespostas (codigo);
                    if (codigo <> 125) and (codigo <> 150) then
                        mensagem ('FTPEDREC', 1);  {'Pedido de informaes de diretrio foi recusado'}
                end;
        end
    else
        begin
            {$I-}  close (arqLocal);  {$I+}
            ioresult;   // ignora e sai
            exit;
        end;

    while processaTransf(ev) and (codigo <> 425) do
        begin
            if pins <> pret then
                mostraRespostas (codigo);

            if keypressed then
                case upcase (readkey) of
                   #$1b:  if enviaComando ('ABOR') then
                               begin
                                   mostraRespostas (codigo);
                                   fechaConexaoArq;
                                   exit;
                               end;
                else
                    begin
                         mostraTransmitidos;
                         while keypressed do readkey;
                    end;
                end;
        end;

    i := 0;
    repeat
         delay (500);
         processaTransf(ev);
         i := i + 1;
         if pins <> pret then
             mostraRespostas (codigo);
    until (pins <> pret) or (i > 10) or (codigo = 226) or (codigo = 250) or (codigo = 425);

    if (codigo <> 226) and (codigo <> 250) then
        mensagem ('FTERRDIR', 1)  {'Erro na transferencia do diretorio'}
    else
        leDiretorio;
end;

{-------------------------------------------------------------}
{                 moda diretorio remoto atual
{-------------------------------------------------------------}

procedure trocaSubdiretorio;
var s, nome, salva: string;
    i, codigo: integer;
    continua: boolean;
begin
    mensagem ('FTVERDIR', 1);  {'Verificando diretrio atual'}
    if enviaComando ('PWD') then
        begin
            pegaResposta (s, codigo, continua);
            if codigo <> 257 then
                mensagem ('FTNAODIR', 1)  {'No consegui obter o diretrio atual'}
            else
                begin
                    salva := s;
                    while (s <> '') and (s[1] <> '"') do delete (s, 1, 1);
                    delete (s, 1, 1);
                    i := pos ('"', s);
                    if i > 0 then
                        delete (s, i, length (s)-i+1);

                    sintWrite ('');  delay (1000);
                    if s <> '' then
                        sintetiza (s)
                    else
                        sintetiza (salva);
                end;
        end
    else
        exit;

    mensagem ('FTQUEDIR', 1);    {'Qual o nome do diretorio remoto desejado ? '}
    sintReadln (nome);
    if nome = ''   then
        begin
            mensagem ('FTDESIS', 1);  {'Desistiu'}
            exit;
        end;

    if      nome = '..' then   s := 'CDUP'
    else                       s := 'CWD '+ nome;

    if enviaComando (s) then
        begin
            mostraRespostas (codigo);
            if (codigo = 250) or (codigo = 200) then
                mensagem ('FTOK', 1)  {'OK'}
            else
                mensagem ('FTNAOTRO', 1);  {'No consegui trocar'}
        end;
end;

end.

