{-------------------------------------------------------------}
{
{    Programa de Transferncia Remota de Arquivos
{
{    Autor: Jose' Antonio Borges
{
{    Em 21/04/98
{
{-------------------------------------------------------------}

{-------------------------------------------------------------}
{                arquivos de inclusao obrigatoria
{-------------------------------------------------------------}

uses dvCrt, dvWin, dvForm, sysUtils, winsock, winprocs,
     ftpVars, ftpMsg, ftpLogin, ftpDir, ftpDlg, ftpRede, ftpArq, ftpPort;

{-------------------------------------------------------------}
{                     rotina de inicializacao
{-------------------------------------------------------------}

function inicializa: boolean;
var
    tempPath, tempFileName: array [0..144] of char;
    tituloJan: array [0..144] of char;

begin
    sintInic (0, sintAmbiente ('FTPVOX', 'DIRFTPVOX'));

    clrscr;
    setWindowText (crtWindow, 'FTPVOX');

    textBackground (BLUE);
    mensagem ('FTINIC', 0);  {'FTP VOX - NCE/UFRJ - v.'}
    writeln (VERSAO);
    sintSoletra (VERSAO);
    textBackground (BLACK);
    writeln;

    debug := false;
    processando := true;
    fimProg := false;
    canalAberto := false;
    escutando := false;

    totalTransmitido := 0;
    verboso := false;
    pins := 0;
    pret := 0;
    linhaParcial := '';
    portaLocal := $400 + 20;

    modoPassivo := not (copy (sintAmbiente ('FTPVOX', 'PASSIVO'), 1, 1) <> 'N');
    selModoPassivo;   // inverte

    getTempPath (144, tempPath);
    getTempFileName(tempPath, 'dir', 0, tempFileName);
    nomeArqDir := strPas (tempFileName);

    if paramcount > 0 then
        nomeHost := paramStr(1)
    else
        begin
            mensagem ('FTCOMPUT', 0);  {'Nome do computador: '}
            sintReadln (nomeHost);
        end;

    strPCopy (tituloJan, 'FTPVOX ' + nomeHost);
    setWindowText (crtWindow, tituloJan);

    porta := 21;
    portaPassiva := 9999;

    inicializa := nomeHost <> '';
end;

{-------------------------------------------------------------}
{                         ajuda
{-------------------------------------------------------------}

procedure ajuda;
begin
    mensagem ('FTAJUD00', 1);  {'As opoes so'}
    mensagem ('FTAJUD01', 1);  {'  L  login conta e senha'}
    mensagem ('FTAJUD03', 1);  {'  R  receber arquivo remoto'}
    mensagem ('FTAJUD04', 1);  {'  T  transmitir'}
    mensagem ('FTAJUD07', 1);  {'  Q  Informar quantidade transmitida'}
    mensagem ('FTAJUD02', 1);  {'  D  diretorio remoto'}
    mensagem ('FTAJUD05', 1);  {'  A  apagar arquivo'}
    mensagem ('FTAJUD8C', 1);  {'  I  Identificao do diretrio atual'}
    mensagem ('FTAJUD06', 1);  {'  S  Trocar subdiretorio'}
    mensagem ('FTAJUD8D', 1);  {'  C  Criar subdiretrio'}
    mensagem ('FTAJUD08', 1);  {'  V  modo verborgico'}
    mensagem ('FTAJUD8A', 1);  {'  P  modo passivo'}
    mensagem ('FTAJUD8B', 1);  {'  /  comandos do ftp'}
    mensagem ('FTAJUD09', 1);  {'  ?  ajuda'}
    mensagem ('FTAJUD10', 1);  {'ESC  fim do programa'}
    while keypressed do readkey;
    sintBip;
end;

{--------------------------------------------------------}
{            seleciona a opo com as setas
{--------------------------------------------------------}

function selSetasOpcao: char;

    procedure MenuAdiciona (msg: string);
    begin
         popupMenuAdiciona (msg, pegaTextoMensagem (msg));
    end;

var n: integer;
const
    tabLetrasOpcoes: string [13] = 'lrtqdaiscvp/?';

begin
    popupMenuCria (wherex, wherey, 50, 13, MAGENTA);
    MenuAdiciona ('FTAJUD01');  {'  L  login conta e senha'}
    MenuAdiciona ('FTAJUD03');  {'  R  receber arquivo remoto'}
    MenuAdiciona ('FTAJUD04');  {'  T  transmitir'}
    MenuAdiciona ('FTAJUD07');  {'  Q  Informar quantidade transmitida'}
    MenuAdiciona ('FTAJUD02');  {'  D  diretorio remoto'}
    MenuAdiciona ('FTAJUD05');  {'  A  apagar arquivo'}
    MenuAdiciona ('FTAJUD8C');  {'  I  Identificao do diretrio atual'}
    MenuAdiciona ('FTAJUD06');  {'  S  Trocar subdiretorio'}
    MenuAdiciona ('FTAJUD8D');  {'  C  Criar subdiretrio'}
    MenuAdiciona ('FTAJUD08');  {'  V  modo verborgico'}
    MenuAdiciona ('FTAJUD8A');  {'  P  modo passivo'}
    MenuAdiciona ('FTAJUD8B');  {'  /  comandos do ftp'}
    MenuAdiciona ('FTAJUD09');  {'  ?  ajuda'}
    MenuAdiciona ('FTAJUD10');  {'ESC  fim do programa'}
    while keypressed do readkey;

    n := popupMenuSeleciona;
    if n > 0 then
        selSetasOpcao := tabLetrasOpcoes[n]
    else
        selSetasOpcao := ENTER;
end;

{-------------------------------------------------------------}
{               cria diretrio remoto
{-------------------------------------------------------------}

procedure criaDiretorio;
var
    nome, s: string;
    codigo: integer;

begin
    mensagem ('FTQUESBD', 1);    {'Qual o nome do subdiretorio? '}
    sintReadln (nome);

    if nome = ''   then
        begin
            mensagem ('FTDESIS', 1);  {'Desistiu'}
            exit;
        end;

    if nome = '..' then   s := 'MKD'
    else                  s := 'MKD '+ nome;

    if enviaComando (s) then
        begin
            mostraRespostas (codigo);
            if (codigo = 257) then
                mensagem ('FTOK', 1)  {'OK'}
            else
                mensagem ('FTNCRIA', 1);  {'No consegui criar'}
        end;
end;

{-------------------------------------------------------------}
{                     processa tecla
{-------------------------------------------------------------}

procedure processaTecla;
var c, c1: char;
    s: string;
    codigo: integer;

label executa;
begin
    fimProg := false;

    c := sintReadKey;
    c1 := #0;
    if c = #0 then
        begin
            c1 := readkey;
            if c1 in [#16..#18] then
                c := readkey; {ALT-GR q,w,e}
        end;

    if c = #0 then
        begin
           if (c1 = CIMA) or (c1 = BAIX) then
                begin
                    c := selSetasOpcao;
                    goto executa;
                end
           else
           if c1 = F1 then
               ajuda
           else
               goto executa;

           exit;
        end;

executa:
    writeln (c);
    case upcase(c) of

        ENTER: ;
        '?':  ajuda;

        'L':  pedeContaESenha;
        'R':  iniciaRecepcao ('');
        'T':  iniciaEnvio;
        'D':  processaDiretorio;
        'Q':  mostraTransmitidos;
        'P':  selModoPassivo;

        'A':  apagaArquivo;
        'S':  trocaSubdiretorio;

        'V':
            begin
                verboso := not verboso;
                if verboso then
                   mensagem ('FTVERBO', 1)  {'Modo verborragico ligado'}
                else
                   mensagem ('FTNAOVRB', 1);  {'Modo verborragico desligado'}
            end;

        'I':
            begin;
                if enviaComando ('PWD') then
                    falaRespostas (codigo, false);
            end;

        'C':  criaDiretorio;

        '/':
            begin
                mensagem ('FTCMDFTP', 1);  {'Entre o comando em codigo FTP'}
                sintReadln (s);
                if enviaComando (s) then
                    falaRespostas (codigo, true);
            end;

        #$1b:
            begin
                fimProg := true;
                if enviaComando ('QUIT') then
                    mostraRespostas (codigo);
                processando := false;
            end;

    else
        mensagem ('FTERRCMD', 1);  {'Comando inexistente'}
    end;

    { por garantia }

    while pins <> pret do
        mostraRespostas (codigo);
end;

{-------------------------------------------------------------}
{                      termina o programa
{-------------------------------------------------------------}

procedure terminaProg;
begin
    assign (arqLocal, nomeArqDir);
    {$I-}  erase (arqLocal);  {$I+}
    if ioresult <> 0 then;

    mensagem ('FTFIMPRG', 1);  {'Programa terminado'}
    sintFim;
    delay (1000);

    doneWinCrt;
end;

{-------------------------------------------------------------}
{                       programa principal
{-------------------------------------------------------------}

var ev: integer;
    s: string;
    codigo: integer;
    continua: boolean;
label fim;
begin
    if not inicializa then
        terminaProg;

    if abreConexao then
       begin
           repeat
               processaRede;
               while pins <> pret do
                   pegaResposta (s, codigo, continua);
               if (codigo <> 220) and (not continua) then
                   begin
                       mensagem ('FTERRSRV', 1);  {'Servidor no est disponvel, codigo'}
                       sintWriteln (s);
                       goto fim;
                   end;
           until not continua;

           pedeContaeSenha;

           textBackground (BLUE);
           mensagem ('FTCMD', 0);  {'Comando ? '}
           textBackground (BLACK);

           while (processando)  do
               begin
                   if keypressed then
                      begin
                          processaTecla;

                          if (not fimProg) then
                              begin
                                  textBackground (BLUE);
                                  mensagem ('FTCMD', 0);  {'Comando ? '}
                                  textBackground (BLACK);
                              end;
                      end;

                   ev := checaEventoRede;
                   if ev = CHEGOU_REDE then
                       begin
                           processaRede;

                           while pins <> pret do
                               begin
                                   pegaResposta (s, codigo, continua);
                                   case codigo of
                                       221:  mensagem ('FTDESCON', 1);  {'Desconectando'}
                                       226:  mensagem ('FTFIMENV', 1);  {'Envio Completado'}
                                   else
                                       if not verboso then
                                           sintWriteln (s);
                                   end;

                               end;
                       end;
               end;
       end;

fim:
    fechaConexao;
    terminaProg;
end.
